require_relative 'gameplay_into_base64'
require_relative 'self'

module Sashite
  module CGN
    class Actor
      PATTERN = /(#{Self::PATTERN}|#{GameplayIntoBase64::PATTERN})/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        Self.loadable?(io) ? Self.load : GameplayIntoBase64.load(io)
      end

      def self.dumpable? io
        Self.dumpable?(io) || GameplayIntoBase64.dumpable?(io)
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        Self.dumpable?(io) ? Self.dump : GameplayIntoBase64.dump(io)
      end
    end
  end
end
