require_relative 'boolean'
require_relative 'null'

module Sashite
  module CGN
    module Ally
      PATTERN = /(#{Boolean::PATTERN}|#{Null::PATTERN})/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        Null.loadable?(io) ? Null.load : Boolean.load(io)
      end

      def self.dumpable? io
        Boolean.dumpable?(io) || Null.dumpable?(io)
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        Null.dumpable?(io) ? Null.dump : Boolean.dump(io)
      end
    end
  end
end
