module Sashite
  module CGN
    module Area
      PATTERN = /(all|furthest_rank|palace|furthest_one-third|nearest_two-thirds)/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        io.to_sym
      end

      def self.dumpable? io
        loadable? io.to_s
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        io.to_s
      end
    end
  end
end
