module Sashite
  module CGN
    module Boolean
      PATTERN = /[ft]/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        io.to_sym == :t
      end

      def self.dumpable? io
        [ false, true ].include? io
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        io ? 't' : 'f'
      end
    end
  end
end
