require_relative 'digit_excluding_zero'
require_relative 'zero'

module Sashite
  module CGN
    module Digit
      PATTERN = /(#{Zero::PATTERN}|#{DigitExcludingZero::PATTERN})/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        Zero.loadable?(io) ? Zero.load : DigitExcludingZero.load(io)
      end

      def self.dumpable? io
        Zero.dumpable?(io) || DigitExcludingZero.dumpable?(io)
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        Zero.dumpable?(io) ? Zero.dump(io) : DigitExcludingZero.dump(io)
      end
    end
  end
end
