module Sashite
  module CGN
    module DigitExcludingZero
      PATTERN = /[1-9]/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        io.to_i
      end

      def self.dumpable? io
        loadable? io.to_s
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        io.to_s
      end
    end
  end
end
