require_relative 'integer'

module Sashite
  module CGN
    module Direction
      PATTERN = /(#{Integer::PATTERN},)*#{Integer::PATTERN}/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        io.split(',').map { |s| Integer.load s }
      end

      def self.dumpable? io
        io.is_a?(Array) &&
        io.all? {|i| Integer.dumpable? i }
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        io.join(',')
      end
    end
  end
end
