require_relative 'pattern'

module Sashite
  module CGN
    module Gameplay
      PATTERN = /#{Pattern::PATTERN}(\. #{Pattern::PATTERN})*\./

      def self.loadable? io
        io.match("^#{PATTERN}$") &&
        io.split('. ').sort.join('. ') == io &&
        io[0..-2].split('. ').uniq.join('. ').concat('.') == io
      end

      def self.load io
        raise ArgumentError unless loadable? io

        io[0..-2].split('. ').map { |s| Pattern.load s }
      end

      def self.dumpable? io
        io.is_a?(Array) &&
        io.length == io.uniq.length &&
        io.all? {|p| Pattern.dumpable? p }
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        patterns = io.map {|a| Pattern.dump a }
        patterns.join('. ').concat('.')
      end
    end
  end
end
