require 'base64'
require_relative 'gameplay'

module Sashite
  module CGN
    module GameplayIntoBase64
      PATTERN = /(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?/

      def self.loadable? io
        io.match("^#{PATTERN}$") &&
        Gameplay.loadable?(Base64.strict_decode64(io))
      end

      def self.load io
        raise ArgumentError unless loadable? io

        Gameplay.load Base64.strict_decode64(io)
      end

      def self.dumpable? io
        Gameplay.dumpable? io
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        Base64.strict_encode64 Gameplay.dump(io)
      end
    end
  end
end
