require_relative 'negative_integer'
require_relative 'unsigned_integer'

module Sashite
  module CGN
    module Integer
      PATTERN = /(#{NegativeInteger::PATTERN}|#{UnsignedInteger::PATTERN})/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        NegativeInteger.loadable?(io) ? NegativeInteger.load(io) : UnsignedInteger.load(io)
      end

      def self.dumpable? io
        NegativeInteger.dumpable?(io) || UnsignedInteger.dumpable?(io)
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        NegativeInteger.dumpable?(io) ? NegativeInteger.dump(io) : UnsignedInteger.dump(io)
      end
    end
  end
end
