require_relative 'null'
require_relative 'unsigned_integer_excluding_zero'

module Sashite
  module CGN
    module MaximumMagnitude
      PATTERN = /(#{Null::PATTERN}|#{UnsignedIntegerExcludingZero::PATTERN})/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        Null.loadable?(io) ? Null.load : UnsignedIntegerExcludingZero.load(io)
      end

      def self.dumpable? io
        UnsignedIntegerExcludingZero.dumpable?(io) || Null.dumpable?(io)
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        Null.dumpable?(io) ? Null.dump : UnsignedIntegerExcludingZero.dump(io)
      end
    end
  end
end
