module Sashite
  module CGN
    module Name
      PATTERN = /(capture|remove|shift)/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        io.to_sym
      end

      def self.dumpable? io
        %i(capture remove shift).include? io
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        io.to_s
      end
    end
  end
end
