require_relative 'boolean'
require_relative 'null'
require_relative 'subject'

module Sashite
  module CGN
    module Occupied
      PATTERN = /(#{Null::PATTERN}|#{Boolean::PATTERN}|#{Subject::PATTERN}|an_ally_actor|an_enemy_actor)/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        if Null.loadable? io
          Null.load
        elsif Boolean.loadable? io
          Boolean.load io
        elsif Subject.loadable? io
          Subject.load io
        else
          io.to_sym
        end
      end

      def self.dumpable? io
        Null.dumpable?(io) ||
        Boolean.dumpable?(io) ||
        Subject.dumpable?(io) ||
        io == :an_ally_actor ||
        io == :an_enemy_actor
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        if Null.dumpable?(io)
          Null.dump(io)
        elsif Boolean.dumpable?(io)
          Boolean.dump(io)
        elsif Subject.dumpable?(io)
          Subject.dump(io)
        elsif io == :an_ally_actor
          'an_ally_actor'
        elsif io == :an_enemy_actor
          'an_enemy_actor'
        end
      end
    end
  end
end
