require_relative 'ability'

module Sashite
  module CGN
    module Pattern
      PATTERN = /#{Ability::PATTERN}(; #{Ability::PATTERN})*/

      def self.loadable? io
        io.match("^#{PATTERN}$") &&
        io.split('; ').uniq.join('; ') == io
      end

      def self.load io
        raise ArgumentError unless loadable? io

        io.split('; ').map { |ability| Ability.load ability }
      end

      def self.dumpable? io
        io.is_a?(Array) &&
        io.length == io.uniq.length &&
        io.all? {|a| Ability.dumpable? a }
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        abilities = io.map {|a| Ability.dump a }
        abilities.join('; ')
      end
    end
  end
end
