require_relative 'null'
require_relative 'unsigned_integer'

module Sashite
  module CGN
    module PreviousMovesCounter
      PATTERN = /(#{Null::PATTERN}|#{UnsignedInteger::PATTERN})/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        Null.loadable?(io) ? Null.load : UnsignedInteger.load(io)
      end

      def self.dumpable? io
        Null.dumpable?(io) || UnsignedInteger.dumpable?(io)
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        Null.dumpable?(io) ? Null.dump : UnsignedInteger.dump(io)
      end
    end
  end
end
