module Sashite
  module CGN
    module Self
      PATTERN = /self/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io = 'self'
        raise ArgumentError unless loadable?(io)

        :self
      end

      def self.dumpable? io
        io == :self
      end

      def self.dump io = :self
        raise ArgumentError unless dumpable? io

        'self'
      end
    end
  end
end
