require_relative 'last_moved_actor'
require_relative 'previous_moves_counter'

module Sashite
  module CGN
    module State
      PATTERN = /#{LastMovedActor::PATTERN}&#{PreviousMovesCounter::PATTERN}/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        last_moved_actor = LastMovedActor.load io.split('&').fetch(0)
        previous_moves_counter = PreviousMovesCounter.load io.split('&').fetch(1)

        {
          :"...last_moved_actor?" => last_moved_actor,
          :"...previous_moves_counter" => previous_moves_counter
        }
      end

      def self.dumpable? io
        io.is_a?(Hash) &&
        io.keys.sort == %i(...last_moved_actor? ...previous_moves_counter) &&
        LastMovedActor.dumpable?(io.fetch(:'...last_moved_actor?')) &&
        PreviousMovesCounter.dumpable?(io.fetch(:'...previous_moves_counter'))
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        LastMovedActor.dump(io.fetch(:'...last_moved_actor?')) + '&' +
        PreviousMovesCounter.dump(io.fetch(:'...previous_moves_counter'))
      end
    end
  end
end
