require_relative 'unsigned_integer_excluding_zero'
require_relative 'zero'

module Sashite
  module CGN
    module UnsignedInteger
      PATTERN = /(#{Zero::PATTERN}|#{UnsignedIntegerExcludingZero::PATTERN})/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io
        raise ArgumentError unless loadable? io

        Zero.loadable?(io) ? Zero.load : UnsignedIntegerExcludingZero.load(io)
      end

      def self.dumpable? io
        loadable? io.to_s
      end

      def self.dump io
        raise ArgumentError unless dumpable? io

        io.to_s
      end
    end
  end
end
