module Sashite
  module CGN
    module Zero
      PATTERN = /0/

      def self.loadable? io
        !!io.match("^#{PATTERN}$")
      end

      def self.load io = '0'
        raise ArgumentError unless loadable?(io)

        0
      end

      def self.dumpable? io
        io == 0
      end

      def self.dump io = 0
        raise ArgumentError unless dumpable? io

        '0'
      end
    end
  end
end
